# countdown-js
`countdown-js` is a jQuery plugin to render countdowns.

![image](http://ojc5f5uwt.bkt.clouddn.com/countdown.png)

## Setup
Add the folloing lines to the `head` of your website:
```
<script type="text/javascript" src="http://cdn.bootcss.com/jquery/1.7.2/jquery.min.js"></script>
<script type="text/javascript" src="/path/to/jquery.countdown.min.js"></script>
```
Then you have to initialize the plugin with your config:
```
$('.countdown.color').countdown({'placeholderColor': 'black', 'color': 'red'});
```
Please check `examples/index.html` for how to use.

Enjoy the time you saved!

## Options
You can pass a set of these options to set a custom behaviour and look for the plugin.<br>

|Property  |Default  |Description  |
| --- | --- | --- |
|state  |{'text':'', 'color':'black', 'font-size':'12px', 'scale':0.8}  |The state of your countdown. If `state.text` is empty, it will not show.  `scale` will be used for `transform:scale($scale)` attribute.|
|placeholderColor |#f1f1f1 |The default digit foreground color |
|color |#b00d1d |The running digit foreground color|
|maxNumWidth |26 |The max digit width (in pixel)|
|borderWidth |4 |Border width (in pixel)|
|colonWidth |5 |`':'` width (in pixel)|
|dotWidth |3 |`'.'` width (in pixel)|
|numMargin |3 | Margin between digit、colon|
|microMargin |1 | Margin nearby `'.'`|
|bm |[1,2,2,1] |Digital vertical spacing |
|onEnd |function(){} |Callback function when countdown end |
|onRunning |[{<br>left:xxx, <br>callback: fn(countdown){}<br>}, ...] |Callbacks when countdown remaining |


## Public plugin methods

|Method(arguments) |Description |
| --- | --- | --- |
|stop |Stops the refresh loop. |
|restart(cd, options) |Update the options and restart the countdown. |

## License
`countdown-js` is dual licensed under the MIT licenses.
